<template>
  <div v-if="node" class="mt-4">
    <h3 class="text-lg font-bold mb-2">Selected Node</h3>
    <button @click="goToParentNode" class="px-4 py-2 rounded mb-2"
      :class="{ 'bg-gray-600 text-white': isDarkMode, 'bg-gray-300 text-gray-700': !isDarkMode }"
      :disabled="!node.parent">
      Back to Parent
    </button>
    <pre class="p-4 rounded overflow-auto"
      :class="{ 'bg-gray-800 text-white': isDarkMode, 'bg-gray-100': !isDarkMode }">
      <vue-json-pretty :data="nodeData" :showDoubleQuotes="false" :deep="1" @nodeClick="onNodeClick" />
    </pre>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, watch } from 'vue';
import type { SyntaxNode } from 'web-tree-sitter';
import VueJsonPretty from 'vue-json-pretty';
import 'vue-json-pretty/lib/styles.css';

export default defineComponent({
  name: 'NodeViewer',
  components: {
    VueJsonPretty,
  },
  props: {
    node: {
      type: Object as () => SyntaxNode | null,
      required: true,
    },
    isDarkMode: {
      type: Boolean,
      required: true,
    },
  },
  setup(props) {
    const currentNode = ref(props.node);
    console.log(currentNode.value)

    const nodeData = ref({});

    const updateNodeData = () => {
      if (currentNode.value) {
        nodeData.value = {
          type: currentNode.value.type,
          text: currentNode.value.text,
          startPosition: currentNode.value.startPosition,
          endPosition: currentNode.value.endPosition,
          children: currentNode.value.children ? currentNode.value.children.map((child) => ({
            type: child.type,
            startPosition: child.startPosition,
            endPosition: child.endPosition,
          })) : [],
        };
      }
    };

    const onNodeClick = (node: { key: string; value: any }) => {
      if (node.key === 'children') {
        const childNode = currentNode.value?.children?.find(
          (child) =>
            child.type === node.value.type &&
            child.startPosition === node.value.startPosition &&
            child.endPosition === node.value.endPosition
        );
        if (childNode) {
          currentNode.value = childNode;
          updateNodeData();
        }
      }
    };

    const goToParentNode = () => {
      if (currentNode.value?.parent) {
        currentNode.value = currentNode.value.parent;
        updateNodeData();
      }
    };

    watch(
      () => props.node,
      (newNode) => {
        currentNode.value = newNode;
        updateNodeData();
      }
    );

    updateNodeData();

    return {
      nodeData,
      onNodeClick,
      goToParentNode,
    };
  },
});
</script>